// const userCenterBaseUrl = 'http://192.168.0.108:7001/usercenter';
const userCenterBaseUrl = 'http://39.104.74.123:8081/usercenter'; //正式服务器
// const evalutaionBaseUrl = 'http://127.0.0.1:7003/evaluation';
// const evalutaionBaseUrl = 'http://192.168.0.108:7003/evaluation';
const evalutaionBaseUrl = 'http://39.104.74.123:8082/evaluation'; //正式服务器
const missionList = evalutaionBaseUrl + '/app/apptask/listtasktoapp';

function pathArgsHasSameValue(pathArgArray) {
	var tempArgIndex = 0;
	var tempArgs = pathArgArray[tempArgIndex];
	for (var i = (tempArgIndex + 1), item; item = pathArgArray[i]; i++) {
		if (tempArgs == item) {
			throw new Error('参数' + item + '有重复值!!!');
		}
		if (i == pathArgArray.length - 1) {
			tempArgs = pathArgArray[++tempArgIndex];
			i = tempArgIndex;
			continue;
		}
	}
}

function buildPath(basePath, pathArgs) {
	var path = basePath;
	if (!basePath || !(typeof(basePath) == 'string')) {
		throw new Error('basePath必须为字符串!!!');
	}
	if (!pathArgs || !Array.isArray(pathArgs)) {
		throw new Error('pathArgs必须为数组!!!');
	}
	var pathArgArray = basePath.match(/\{\w+\}/g);
	if (!pathArgArray) {
		return path;
	}
	pathArgsHasSameValue(pathArgArray);
	for (var i = 0, item; item = pathArgArray[i]; i++) {
		path = path.replace(item, pathArgs[i]);
	}
	return path;
}

function uuid() {
	return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
		var r = Math.random() * 16 | 0,
			v = c == 'x' ? r : (r & 0x3 | 0x8);
		return v.toString(16);
	});
}
const _keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";

function encode(input) {
	var output = "";
	var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
	var i = 0;
	input = _utf8_encode(input);
	while (i < input.length) {
		chr1 = input.charCodeAt(i++);
		chr2 = input.charCodeAt(i++);
		chr3 = input.charCodeAt(i++);
		enc1 = chr1 >> 2;
		enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
		enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
		enc4 = chr3 & 63;
		if (isNaN(chr2)) {
			enc3 = enc4 = 64;
		} else if (isNaN(chr3)) {
			enc4 = 64;
		}
		output = output +
			_keyStr.charAt(enc1) + _keyStr.charAt(enc2) +
			_keyStr.charAt(enc3) + _keyStr.charAt(enc4);
	}
	return output;
}

function decode(input) {
	var output = "";
	var chr1, chr2, chr3;
	var enc1, enc2, enc3, enc4;
	var i = 0;
	input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
	while (i < input.length) {
		enc1 = _keyStr.indexOf(input.charAt(i++));
		enc2 = _keyStr.indexOf(input.charAt(i++));
		enc3 = _keyStr.indexOf(input.charAt(i++));
		enc4 = _keyStr.indexOf(input.charAt(i++));
		chr1 = (enc1 << 2) | (enc2 >> 4);
		chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
		chr3 = ((enc3 & 3) << 6) | enc4;
		output = output + String.fromCharCode(chr1);
		if (enc3 != 64) {
			output = output + String.fromCharCode(chr2);
		}
		if (enc4 != 64) {
			output = output + String.fromCharCode(chr3);
		}
	}
	output = _utf8_decode(output);
	return output;
}

function _utf8_encode(string) {
	string = string.replace(/\r\n/g, "\n");
	var utftext = "";
	for (var n = 0; n < string.length; n++) {
		var c = string.charCodeAt(n);
		if (c < 128) {
			utftext += String.fromCharCode(c);
		} else if ((c > 127) && (c < 2048)) {
			utftext += String.fromCharCode((c >> 6) | 192);
			utftext += String.fromCharCode((c & 63) | 128);
		} else {
			utftext += String.fromCharCode((c >> 12) | 224);
			utftext += String.fromCharCode(((c >> 6) & 63) | 128);
			utftext += String.fromCharCode((c & 63) | 128);
		}

	}
	return utftext;
}

function _utf8_decode(utftext) {
	var string = "";
	var i = 0;
	var c = 0;
	var c1 = 0;
	var c2 = 0;
	while (i < utftext.length) {
		c = utftext.charCodeAt(i);
		if (c < 128) {
			string += String.fromCharCode(c);
			i++;
		} else if ((c > 191) && (c < 224)) {
			c2 = utftext.charCodeAt(i + 1);
			string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
			i += 2;
		} else {
			c2 = utftext.charCodeAt(i + 1);
			c3 = utftext.charCodeAt(i + 2);
			string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
			i += 3;
		}
	}
	return string;
}
export default {
	userCenterBaseUrl: userCenterBaseUrl,
	evalutaionBaseUrl: evalutaionBaseUrl,
	path: buildPath,
	uuid: uuid,
	encode: encode,
	decode: decode,
	_utf8_decode: _utf8_decode,
	_utf8_encode: _utf8_encode
}
